#include "persia.h"

void
persia_add_pre_frame_hook (void (*fn_ptr)())
{
  if (ViewState->num_c_hooks < PERSIA_MAX_NUM_C_HOOKS)
    {
      ViewState->c_hooks[ViewState->num_c_hooks] = fn_ptr;
      ViewState->num_c_hooks++;
    }
  else
    pfNotify(PFNFY_FATAL, PFNFY_RESOURCE, 
	     "maximum number of C hooks exceeded");
}

void persia_add_pre_frame_hook_before (void (*ref_ptr)(), void (*hook_ptr)())
{
  if (ViewState->num_c_hooks < PERSIA_MAX_NUM_C_HOOKS)
    {
      int i, j;
      /* Find the ref_ptr. */
      for (i = 0; i < ViewState->num_c_hooks; i++)
	if (ViewState->c_hooks[i] == ref_ptr)
	  break;
      /* xxx I assume that if we fall out of thie loop, then i==num_c_hooks */
      /* Make room for hook_ptr. */
      for (j = ViewState->num_c_hooks; j > i; j--)
	ViewState->c_hooks[j] = ViewState->c_hooks[j-1];
      /* Put it in. */
      ViewState->c_hooks[i] = hook_ptr;
      ViewState->num_c_hooks++;
    }
  else
    pfNotify(PFNFY_FATAL, PFNFY_RESOURCE, 
	     "maximum number of C hooks exceeded");
}

void persia_add_pre_frame_hook_after (void (*ref_ptr)(), void (*hook_ptr)())
{
  if (ViewState->num_c_hooks < PERSIA_MAX_NUM_C_HOOKS)
    {
      int i;
      /* Find the ref_ptr. */
      for (i = 0; i < ViewState->num_c_hooks; i++)
	if (ViewState->c_hooks[i] == ref_ptr)
	  break;
      /* xxx I assume that if we fall out of thie loop, then i==num_c_hooks */
      if (i != ViewState->num_c_hooks)
	{
	  int j;
	  /* Make room for hook_ptr. */
	  for (j = ViewState->num_c_hooks; j > i+1; j--)
	    ViewState->c_hooks[j] = ViewState->c_hooks[j-1];
	}
      /* Put it in. */
      ViewState->c_hooks[i+1] = hook_ptr;
      ViewState->num_c_hooks++;
    }
  else
    pfNotify(PFNFY_FATAL, PFNFY_RESOURCE, 
	     "maximum number of C hooks exceeded");
}

void
persia_remove_pre_frame_hook (void (*fn_ptr)())
{
  int i = 0;
  while (ViewState->c_hooks[i] != fn_ptr 
	 && i < ViewState->num_c_hooks)
    i++;

  if (i == ViewState->num_c_hooks)
    return;			/* not found */

  while (i < ViewState->num_c_hooks - 1)
    ViewState->c_hooks[i] = ViewState->c_hooks[i+1];

  ViewState->num_c_hooks--;
}
