(require 'persia)
(require 'headhand)
(require 'iscan)

(ps:init-cameras 1)
(ps:headhand-start)
(ps:iscan-start)

;;; Put the ps:*head-dcs* in the scene by making it 
;;; a direct child of the scene.
(pf:add-child ps:*scene-group* ps:*head-dcs*)

;;; Put the ps:*eye-dcs* in the scene by making it a
;;; direct child of the ps:*head-dcs*
(pf:add-child ps:*head-dcs* ps:*eye-dcs*)

;;; Load the cow object.
(define cow-geode (ps:make-node-from-file "cow.obj"))

;;; Attach the cow to the ps:*head-dcs*, 
;;; so that rotations of the ps*head-dcs* will rotate the cow.
(pf:add-child ps:*head-dcs* cow-geode)

(define eye-ray (ps:make-geode-cube
		 .1 100. .1
		 (cons 'gstate (ps:make-gstate '(color . #(.5 .5 .1))))))
(pf:add-child ps:*eye-dcs* eye-ray)

(ps:run)
