;;; tex-cube.scm - demo of creating a textured cube

(require 'persia)               ; Load "Persia" definitions

;;; Place window in upper left-hand corner of screen.  This must come
;;; before ps:init-cameras.
(ps:position-window 0 50 980 300 300)

(ps:init-cameras 1)             ; Must come before any graphics code

(define cube 
  (ps:make-geode-cube
   10. 20. 30.
   (cons 'gstate (ps:make-gstate
		  '(color . #(.9 .9 .9))
		  '(texture-file . "grass2.rgb")))
   (cons 'texture-scale 20.)))

(ps:place-node cube             ; Put the cube in the world scene
	       0. 0. 0.)        ; at x 0, y 0, z 0

(ps:run)                        ; Start draw/event loop

;;; Use middle mouse button to rotate cube
;;; To exit loop, press <esc> while mouse is in graphics window
