;;; tex-plane.scm - demo of creating a textured plane

(require 'persia)               ; Load "Persia" definitions

;;; Place window in upper left-hand corner of screen.  This must come
;;; before ps:init-cameras.
(ps:window-position 50 980 300 300)

(ps:init-cameras 1)             ; Must come before any graphics code

(define plane
  (ps:make-geode-plane 10. 30.
   `(gstate . ,(ps:make-gstate
	      '(color . #(.9 .9 .9))
	      '(texture-file . "grass2.rgb")))
   '(texture-scale . 20.)))

(ps:place-node plane            ; Put the plane in the world scene
	       0. 0. 0.)        ; at x 0, y 0, z 0

(ps:run)                        ; Start draw/event loop

;;; Use middle mouse button to rotate cube
;;; To exit loop, press <esc> while mouse is in graphics window
