(require 'persia)

(ps:init-cameras 2)

;;; Create a grassy field, 1000x1000, with corner at 0,0
(define field 
  (ps:place-node 
   (ps:make-geode-plane 
    1000. 1000.
    `(gstate . ,(ps:make-gstate '(color . #(.1 .6 .1))
				'(texture-file . "grass2.rgb"))))
   .0 .0 0.))

;;; Put camera number 1 at the center of the field by creating a pfDCS node,
;;; placing it in the center of the field, and attaching camera number 1
;;; to it.
(define camera-dcs (pf:new-dcs))
(pf:dcs-trans camera-dcs 500. 500. 4.)
(pf:add-child ps:*scene-group* camera-dcs)
(ps:attach-camera 1 camera-dcs)

;;; create a building, with a porch roof as a subbody
(define building 
  (ps:place-node
   (ps:make-geode-cube 
    40. 30. 55. 
    `(gstate . ,(ps:make-gstate '(color . #(.4 .3 .2)))))
   700. 600. 0. ps:*scene-group*))

(define building-porch-roof
  (ps:place-node 
   (ps:make-geode-cube 
    10. 15. 1.
    `(gstate . ,(ps:make-gstate '(color . #(.2 .1 .1)))))
   -10. 7.5 8. building))

(define rock 
  (ps:place-node
   (ps:make-geode-rock
    50. 80. 20. 3
    `(gstate . ,(ps:make-gstate '(color . #(.4 .1 .2 .4))
				'(texture-file . "grass2.rgb"))))
   400. 400. 0.))

;;; make the mouse X position rotate the camera, and the mouse Y position
;;; rotate the building
(ps:add-pre-frame-hook
 (lambda () 
   (begin
     (pf:dcs-rot camera-dcs 
              (* (/ (ps:mouse-x) (ps:mouse-x-max)) 360.) 0. 0.)
     (pf:dcs-rot building
		 (* (/ (ps:mouse-y) (ps:mouse-y-max)) 360.) 0. 0.))))

;;; start the draw/event loop
(ps:run)
