
#ifndef _FLOCK_H
#define _FLOCK_H

void flock_initialize_devname(char *deviceName, int baudRate);
void flock_initialize_fbb(int FBBAddress, int fileDescriptor);
void flock_initialize();
int flock_open_port(char *devName, int baudRate);

void flock_get_matrix(float trans[3], float rot[3][3]);
void flock_get_two_matrices(float trans1[3], float rot1[3][3],
			    float trans2[3], float rot2[3][3]);

void flock_set_position_scaling (int posScaling);
void flock_set_bird_hemisphere(int hemisphere);
void flock_set_position_matrix_mode();
void flock_set_filters(char filterBits);

void flock_set_num_receivers(int n);
int flock_num_receivers();

extern pfDCS *flock_helmet_dcs;
extern pfDCS *flock_hand_dcs;

int flock_send_byte(char msg);
int flock_send_n_bytes(char *msg, int n_bytes);
int flock_read_n_bytes(char *ch, int n_bytes, int check_flock_bit);

#endif /* _FLOCK_H */
