#include "persia-scm.h"

ulong *
Frame_Capture(ulong cam, ulong *szX, ulong *szY)
{
  ulong *scrbuff;
  ulong xsize, ysize, xorg, yorg;
  
  if ((cam < 0) || (cam >= ViewState->num_cameras))
    return NULL;
  pfGetChanOrigin(Chan[cam], (long *)&xorg, (long *)&yorg);
  pfGetChanSize(Chan[cam], (long *)&xsize, (long *)&ysize);
  scrbuff = (unsigned long *)pfMalloc((uint)(xsize*ysize*sizeof(long)), NULL);
  lrectread((short)xorg, (short)yorg,
	    (short)(xorg+xsize-1), (short)(yorg+ysize-1), scrbuff);
  *szX = xsize;
  *szY = ysize;
  return scrbuff;
}

Object
P_Frame_Capture(Object camera)
{
  Object v;
  ulong xsz, ysz;
  ulong *buff_ptr;
  GC_Node;
  
  Check_Type(camera, T_Fixnum);
  v = Make_Vector(3, Null);
  buff_ptr = Frame_Capture(FIXNUM(camera), &xsz, &ysz);
  if (buff_ptr == NULL)
    return Null;
  GC_Link(v);
  VECTOR(v)->data[0] = Make_Unsigned_Long((ulong)buff_ptr);
  VECTOR(v)->data[1] = Make_Unsigned_Long(xsz);
  VECTOR(v)->data[2] = Make_Unsigned_Long(ysz);
  GC_Unlink;
  return v;
}

/* This function is to allow memory allocated with pfMalloc to be freed from
   w/in Persia.  It should probably be moved to a more central location. */
Object
P_Del_pfMem(Object pfthing)
{
  int memDeleted;           /* boolean */

  Check_Type(pfthing, T_Pfo);
  /* pfDelete reduces reference count on a piece of mem, & clears it when
     the ref count <= 0 */
  memDeleted = pfDelete(PFO(pfthing));
  switch (memDeleted) {
  case -1:
    pfNotify(PFNFY_DEBUG, PFNFY_PRINT,
	     "Attempt to free memory not allocated with pfMalloc.");
    return Null;
  case TRUE:
    return True;
  default:
    return False;
  }
}

#if 0
/* This function returns the reference count of the pfObject passed to it.
   This function should be moved to another file. */
Object
P_GetRef(Object pfthing)
{
  Check_Type(pfthing, T_Pfo);

  return Make_Fixnum(pfGetRef(PFO(pfthing)));
}
#endif

void frame_capture_init ()
{
  Define_Primitive(P_Frame_Capture, "ps:frame-capture", 1, 1, EVAL);
  Define_Primitive(P_Del_pfMem, "ps:Delete", 1, 1, EVAL);
  /* Define_Primitive(P_GetRef, "ps:get-ref-count", 1, 1, EVAL); */
}


