/*
 * Copyright (c) 1993 Silicon Graphics, Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose is hereby granted without
 * fee, provided that (i) the above copyright notices and this
 * permission notice appear in all copies of the software and related
 * documentation, and (ii) the name of Silicon Graphics may not be
 * used in any advertising or publicity relating to the software
 * without the specific, prior written permission of Silicon Graphics.
 * 
 * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
 * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * IN NO EVENT SHALL SILICON GRAPHICS BE LIABLE FOR ANY SPECIAL,
 * INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY
 * THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE
 * OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

/*
 *	  generic.h
 */

#ifndef __GENERIC_H__
#define __GENERIC_H__

#include "main.h"

#define MAX_PIPES	32
#define MAX_CHANS	64
#define HYPERPIPE	2

/* Command Line optional settings used at initialization */
extern long	NotifyLevel;	    
extern long	ProcSplit;
extern long	PrioritizeProcs;
extern long	GangDraw;
extern long	InitHPR;
extern long	InitXYZ;
extern long 	WriteScene;
extern long	WinSizeX, WinSizeY;
extern long	NumFiles;
extern long	NumPipes;
extern long	NumChans;
extern long	Multipipe;
extern long	ChanOrder[MAX_CHANS];

/* These are visible for the Application process only */
extern char	**DatabaseFiles;
/* extern pfChannel *Chan[MAX_CHANS]; */
#define Chan ViewState->chans

/* Function Prototypes */
extern long SimDone(void);

extern void InitConfig(void);
extern void InitSharedMem(int, char **, int);
extern void InitScene(void);
extern void InitPipe(void);
extern void InitGUI(void);
extern void InitChannel(void);
extern void OpenPipeline(pfPipe *);
extern void OpenXPipeline(pfPipe *);
extern void InitGfx(pfPipe *);

extern void PreFrame(void);
extern void PostFrame(void);

extern void PreDraw(pfChannel *, void *);
extern void PostDraw(pfChannel *, void *);

extern void PreCull(pfChannel *, void *);
extern void PostCull(pfChannel *, void *);

extern void get_world_coords_of_dcs(pfDCS *dcs, pfMatrix mat);

#endif
