/* Scheme wrappers for dealing with Performer Geode's */

#include "persia-scm.h"

Object P_GetNumGSets(Object geode)
{
  Check_Pfo_Class(geode, PFTYPE_GEODE);
  return Make_Fixnum(pfGetNumGSets(PFN(geode)));
}

Object P_GetGSet(Object geode, Object index)
{
  Check_Pfo_Class(geode, PFTYPE_GEODE);
  Check_Type(index, T_Fixnum);
  return Make_Pfo((pfObject*) pfGetGSet(PFN(geode), FIXNUM(index)));
}


void geodes_init ()
{
  Define_Primitive(P_GetNumGSets, "pf:get-num-gsets", 1, 1, EVAL);
  Define_Primitive(P_GetGSet, "pf:get-gset", 2, 2, EVAL);
}


