/* Scheme wrappers for dealing with Performer GeoSet's */

#include "persia-scm.h"


/*
 * getGSetNumVerts will return the number of vertices in a GeoSet regardless 
 * of the type of GeoSet that it is (lines, vertices, quads, strips, etc...).
 * Should be very useful in those cases where the number of vertices must be
 * known in order to check the number of input parameters (as in the case of
 * setting texture index coordinates.
 */
long getGSetNumVerts (pfGeoSet *gset)
{
  int i = 0;
  long primType = 0;
  long numPrims = 0;
  long numVerts = 0;
  long *lengths = 0;

  numPrims = pfGetGSetNumPrims(gset);
  lengths = pfGetGSetPrimLengths(gset);
  primType = pfGetGSetPrimType(gset);
  fprintf(stdout,"PRIMTYPE: %d\n",primType);
  fprintf(stdout,"Type: %d\n",PFGS_POINTS);
  fprintf(stdout,"Type: %d\n",PFGS_LINES);
  fprintf(stdout,"Type: %d\n",PFGS_LINESTRIPS);
  fprintf(stdout,"Type: %d\n",PFGS_TRISTRIPS);
  fprintf(stdout,"Type: %d\n",PFGS_FLAT_LINESTRIPS);
  fprintf(stdout,"Type: %d\n",PFGS_FLAT_TRISTRIPS);
  fprintf(stdout,"Type: %d\n",PFGS_TRIS);
  fprintf(stdout,"Type: %d\n",PFGS_QUADS);
  switch (primType)
    {
    case PFGS_POINTS:
      numVerts = numPrims;
      break; 
    case PFGS_LINES:
      numVerts = 2 * numPrims;
      break;
    case PFGS_TRIS:
      numVerts = 3 * numPrims;
      break;
    case PFGS_QUADS:
      numVerts = 4 * numPrims;
      break;
    case PFGS_LINESTRIPS:
    case PFGS_FLAT_LINESTRIPS:
    case PFGS_TRISTRIPS:
    case PFGS_FLAT_TRISTRIPS:
      for (i=0;i<numPrims;i++)
	{
	  numVerts += lengths[i];
	}
      break;
    }
  fprintf(stdout,"BWAHAHA %ld\n",numVerts);
  return(numVerts);
}

Object P_GeoSetTex(Object gset, Object a)
{
  void *texcoords=0;
  ushort *texindex=0;
  pfVec2 *twcords;
  ushort *twin;
  Object entry;
  int i;
  pfVec2 tempVec;
  long NumVertInGset=0;
  long in=0;
  long type;
  void *arena;

  fprintf(stdout,"REALTEST: %x\n",PFO(gset));
  
  Check_Pfo_Class(gset, PFTYPE_GEOSET);
  Check_Type(a, T_Vector);

  NumVertInGset = getGSetNumVerts((pfGeoSet *) PFO(gset));
  fprintf(stdout,"blah! %ld %ld\n\n",NumVertInGset,in);

  pfGetGSetAttrLists((pfGeoSet*)PFO(gset),PFGS_TEXCOORD2,&texcoords,&texindex);

  fprintf(stdout, "GOT LISTS\n");
  pfGSetAttr((pfGeoSet*)PFO(gset),PFGS_TEXCOORD2,PFGS_PER_VERTEX,texcoords,texindex);
  fprintf(stdout,"SET LISTS\n");
  fprintf(stdout,"Texcoords: %x\n\n",texcoords);

  for (i = 0; i < 8; i++)
    {
  fprintf(stdout,"blah! %f\n\n",NumVertInGset);
/*
      entry = P_Vector_Ref(a, V_INTS(2*i));
      Check_Type(entry, T_Flonum);
      tempVec[0] = entry;

      texcoords[i][0] = FLONUM(entry)->val;

      entry = P_Vector_Ref(a, V_INTS(2*i+1));
      Check_Type(entry, T_Flonum);

      texcoords[i][1] = FLONUM(entry)->val;
  tempVec[1] = entry;
  pfCopyVec2(texcoords[i],tempVec);
*/
    }


/*
    arena = pfGetSharedArena();
    twcords = (pfVec2 *) pfMalloc (sizeof(pfVec2) * 8, arena);
    twin = (ushort *) pfMalloc (sizeof(ushort) * 24, arena);
    twcords[0][0] = 0.0f; twcords[0][1] = 0.0f;
    twcords[1][0] = 1.0f; twcords[1][1] = 0.0f;
    twcords[2][0] = 1.0f; twcords[2][1] = 1.0f;
    twcords[3][0] = 0.0f; twcords[3][1] = 1.0f;
    twcords[4][0] = 2.0f; twcords[4][1] = 0.0f;
    twcords[5][0] = 1.0f; twcords[5][1] = 1.0f;
    twcords[6][0] = 2.0f; twcords[6][1] = 1.0f;
    twcords[7][0] = 0.0f; twcords[7][1] = 1.0f;

    twin[0] = 6; twin[1] = 4; twin[2] = 0; twin[3] = 7;
    twin[4] = 5; twin[5] = 3; twin[6] = 0; twin[7] = 4;
    twin[8] = 6; twin[9] = 4; twin[10] = 0; twin[11] = 7;
    twin[12] = 5; twin[13] = 3; twin[14] = 0; twin[15] = 4;
    twin[16] = 3; twin[17] = 2; twin[18] = 1; twin[19] = 0;
    twin[20] = 3; twin[21] = 2; twin[22] = 1; twin[23] = 0;

  fprintf(stdout,"BLAHAHAHAHAH %x\n\n",(pfGeoSet*)PFO(gset));
  pfGSetAttr((pfGeoSet*)PFO(gset),PFGS_TEXCOORD2,PFGS_PER_VERTEX,twcords,twin);
*/

  return(gset);
}


/*
void changeGeoSetcolor(pfGeoSet *gset, pfGeoState *in,
		       float red, float green, float blue, float alpha)
{
  ushort **cindex;
  pfVec4 **colors;
  pfColortable *ctab;

  pfGetGSetAttrLists(gset, PFGS_COLOR4, colors, cindex);

  colors[0][0][0] = red;
  colors[0][0][1] = green;
  colors[0][0][2] = blue;
  colors[0][0][3] = alpha;
  ctab = pfGetGStateAttr(in,PFSTATE_COLORTABLE);

  pfCtabColor(ctab,cindex[0][0],colors[0][0]);
}

*/
/*
void changeGeoSettex(pfGeoSet *gset, pfGeoState *in,
		       float red, float green, float blue, float alpha)
{
  ushort **cindex;
  pfVec4 **colors;
  pfColortable *ctab;

  pfGetGSetAttrLists(gset, PFGS_COLOR4, colors, cindex);

  colors[0][0][0] = red;
  colors[0][0][1] = green;
  colors[0][0][2] = blue;
  colors[0][0][3] = alpha;
  ctab = pfGetGStateAttr(in,PFSTATE_COLORTABLE);

  pfCtabColor(ctab,cindex[0][0],colors[0][0]);
}

*/

Object P_GSetGState (Object gset, Object gstate)
{
  pfGeoSet *set;
  pfGeoState *state;

  Check_Pfo_Class(gset, PFTYPE_GEOSET);
  Check_Pfo_Class(gstate, PFTYPE_GEOSTATE);
  set = (pfGeoSet*) PFN(gset);
  state = (pfGeoState*) PFN(gstate);
  pfGSetGState(set, state);
  return Void;
}

Object P_GetGSetGState (Object gset)
{
  pfGeoSet *gs;

  Check_Pfo_Class(gset, PFTYPE_GEOSET);
  gs = (pfGeoSet*) PFN(gset);

  return Make_Pfo((pfObject*) pfGetGSetGState(gs));
}

void gset_init ()
{
  Define_Primitive(P_GeoSetTex, "ps:gset-tex", 2, 2, EVAL);
  Define_Primitive(P_GSetGState, "pf:gset-gstate", 2,2, EVAL);
  Define_Primitive(P_GetGSetGState, "pf:get-gset-gstate", 1, 1, EVAL);
}
