;;; New York Driving - main file

(require 'persia)

;; turns off eye and puts window in visible part of frame buffer
(define making-snapshot #f)

(require 'nyd-world)
(require 'nyd-cars)
(require 'nyd-sm)

(define (general-motion)
  (set! frame-count (+ frame-count 1))
  (if (= (inexact->exact (modulo frame-count 20)) 0)
      (one-tick-update))
  (motion agent-car-attr-list)
  (for-each-vec update-obstacle-car-vec road-vec)
  (do-sacade))

(ps:add-pre-frame-hook general-motion)

;;; This actually changes the FOV of all channels; see gui.c.
(ps:tick)				; we must force init first.
(if doing-vulture (pf:chan-fov vulture-camera -1. 30.))
(pf:chan-fov 0 -1. 30.)
;;(ps:set-fog #t 200. 10000.)  ;; This is good for _LIN
(ps:set-fog #t pf:*fog-vtx-exp* 200. 90000.)  ;; This is good for _EXP

(ps:set-fog #t pf:*fog-vtx-lin* 100. 30000.)
(ps:set-fog #t pf:*fog-vtx-exp* 100. 100000.)
(ps:set-fog #t pf:*fog-vtx-exp2* 100. 40000.)

(ps:run)	   
