/* persia.h - declarations available for C extensions to Persia */

#ifndef __persia_h_INCLUDE
#define __persia_h_INCLUDE

#define Object GLObject
#include <Performer/pf.h>
#include <Performer/pr.h>
#include </usr/src/Performer/include/pfsgi.h>
#include </usr/src/Performer/include/pfutil.h>
#include <perfly.h>
#undef Object

/* Adding and removing pre-frame hook functions */
void persia_add_pre_frame_hook (void (*fn_ptr)());
void persia_add_pre_frame_hook_before (void (*ref_ptr)(), void (*hook_ptr)());
void persia_add_pre_frame_hook_after (void (*ref_ptr)(), void (*hook_ptr)());
void persia_remove_pre_frame_hook (void (*fn_ptr)());

/* The number of frames drawn since Persia executable started. */
#define persia_frame_count (ViewState->frame_count)

/* Current mouse position, bewtween 0 (left, down) and max (up, right). */
#define persia_mouse_x (ViewState->mouse.xpos)
#define persia_mouse_y (ViewState->mouse.ypos)

/* Maximum mouse position */
#define persia_mouse_x_max 1279
#define persia_mouse_y_max 1023

#endif /* __persia_h_INCLUDE */
