/* pfmatrix.c - Scheme interface to Performer pfMatrix */

#include "persia-scm.h"

Object P_MakeIdentMat (Object m)
{
  Check_pfMatrix(m);
  pfMakeIdentMat(PFM(m));
  return Void;
}

Object P_MakeTransMat (Object m, Object x, Object y, Object z)
{
  Check_pfMatrix(m);
  Check_Type(x, T_Flonum);
  Check_Type(y, T_Flonum);
  Check_Type(z, T_Flonum);
  pfMakeTransMat(PFM(m),
		 FLONUM(x)->val,
		 FLONUM(y)->val,
		 FLONUM(z)->val);
  return Void;
}

void pfmatrix_init ()
{
  Define_Primitive(P_MakeIdentMat, "pf:make-ident-mat", 1, 1, EVAL);
  Define_Primitive(P_MakeTransMat, "pf:make-trans-mat", 4, 4, EVAL);
}
