/* scs.c - Scheme interface to Performer pfSCS nodes */

#include "persia-scm.h"

Object P_NewSCS (Object pfmatrix)
{
  Check_pfMatrix(pfmatrix);
  return Make_Pfo((pfObject*) pfNewSCS(PFM(pfmatrix)));
}

Object P_GetSCSMat (Object scs, Object pfmatrix)
{
  Check_pfMatrix(pfmatrix);
  pfGetSCSMat((pfSCS*) PFO(scs), PFM(pfmatrix));
  return Void;
}

Object P_Flatten (Object node, Object mode)
{
  long ret;
  Check_Pfo_Class(node, PFCLASS_NODE);
  Check_Type(mode, T_Fixnum);
  ret = pfFlatten(PFN(node), FIXNUM(mode));
  return Make_Fixnum(ret);
}

Object P_Clone (Object node, Object mode)
{
  Check_Pfo_Class(node, PFCLASS_NODE);
  Check_Type(mode, T_Fixnum);
  return Make_Pfo ((pfObject*) pfClone (PFN(node), FIXNUM(mode)));
}

void scs_init ()
{
  Define_Primitive(P_NewSCS, "pf:new-scs", 1, 1, EVAL);
  Define_Primitive(P_GetSCSMat, "pf:get-scs-mat", 2, 2, EVAL);
  Define_Primitive(P_Flatten, "pf:flatten", 2, 2, EVAL);
  Define_Primitive(P_Flatten, "pf:clone", 2, 2, EVAL);
}
