#include "persia.h"
#include "persia-scm.h"

#include <sys/types.h>
#include <sys/time.h>

Object P_second_count ()
{
  static struct timeval tv;
  static struct timezone tz;
  static long first_second = -1;
  static float second_count;
  
  gettimeofday(&tv, &tz);
  if (first_second == -1)
    {
      first_second = tv.tv_sec;
      second_count = 0.0;
    }
  else
    {
      second_count = (tv.tv_sec - first_second) + (tv.tv_usec / 1000000.0);
    }
  return Make_Flonum(second_count);
}

void time_init ()
{
  Define_Primitive(P_second_count, "ps:second-count", 0, 0, EVAL);
}

